# Copyright (c) 2000-2008, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_with maven

%define _with_repolib 1

# If you want repolib package to be built,
# issue the following: 'rpmbuild --with repolib'
%define with_repolib %{?_with_repolib:1}%{!?_with_repolib:0}
%define without_repolib %{!?_with_repolib:1}%{?_with_repolib:0}

%define repodir %{_javadir}/repository.jboss.com/wscommons-policy/%{version}-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

%define short_name policy

Name:		ws-commons-policy
Version:	1.0
Release:	7%{?dist}
Epoch:		0
Summary:	Web Services Commons - WS-Policy implementation
License:	ASL 2.0
Url:		http://ws.apache.org/commons/policy/
Group:		Text Processing/Markup/XML
# svn export -r '{2006-01-19}' https://svn.apache.org/repos/asf/webservices/commons/trunk/policy ws-commons-policy
Source0:	http://www.mirrorservice.org/sites/ftp.apache.org/ws/commons/policy/1_0/policy-1.0-src.zip
Source1:	%{name}-pom-maven2jpp-depcat.xsl
Source2:	%{name}-pom-maven2jpp-newdepmap.xsl
Source3:	%{name}-pom-maven2jpp-mapdeps.xsl
Source4:        %{name}-jpp-depmap.xml
Source5:	ws-commons-policy-component-info.xml
Source6:        ws-commons-policy-MANIFEST.MF
Patch1:		%{name}-properties.patch
Patch2:		%{name}-om.patch
# FIXME: (dwalluck): Package has an incorrect and unversioned Provides on ws-common-policy
Obsoletes:      neethi <= 1.0.1-1jpp
Obsoletes:      ws-commons-neethi <= 2.0.1-2jpp
BuildRequires:  java-devel
BuildRequires:  jpackage-utils >= 0:1.6
BuildRequires:	junit
%if %with maven
BuildRequires:	maven >= 0:1.0.2
BuildRequires:	maven-plugins-base >= 0:1.0.2
BuildRequires:	maven-plugin-license >= 0:1.0.2
BuildRequires:	maven-plugin-test >= 0:1.0.2
%endif
BuildRequires:	bea-stax >= 0:1.2.0
BuildRequires:	bea-stax-api >= 0:1.2.0
BuildRequires:	jakarta-commons-logging >= 0:1.0.4
BuildRequires:	wsdl4j >= 0:1.5.1
BuildRequires:	saxon-scripts
BuildRequires:  ws-commons-axiom
Requires:	bea-stax >= 0:1.2.0
Requires:	bea-stax-api >= 0:1.2.0
Requires:	jakarta-commons-logging >= 0:1.0.4
Requires:	wsdl4j >= 0:1.5.1
BuildArch:	noarch
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root

%description
WS-Policy implementation, part of Web Services Commons.

%if %{with_repolib}
%package repolib
Summary:	Artifacts to be uploaded to a repository library
Group:		Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%setup -q -n policy-%{version}-src
%patch1 -p0
%patch2 -p0

sed -i -e 's#<name>WS-Policy Implementation</name>##' project.xml

%if %{with_repolib}
tag=`echo %{version}-brew`
sed -i "s/@VERSION@/$tag/g" %{SOURCE5}
tag=`echo %{name}-%{version}-%{release} | sed 's|\.|_|g'`
sed -i "s/@TAG@/$tag/g" %{SOURCE5}
%endif

%build
%if %with maven
mkdir -p $(pwd)/.maven/repository/JPP/jars

export DEPCAT=$(pwd)/%{name}-depcat.new.xml
echo '<?xml version="1.0" standalone="yes"?>' > $DEPCAT
echo '<depset>' >> $DEPCAT
for p in $(find . -name project.xml); do
    pushd $(dirname $p)
    %{_bindir}/saxon project.xml %{SOURCE1} >> $DEPCAT
    popd
done
echo >> $DEPCAT
echo '</depset>' >> $DEPCAT
%{_bindir}/saxon $DEPCAT %{SOURCE2} > %{name}-depmap.new.xml
for p in $(find . -name project.xml); do
    pushd $(dirname $p)
    cp project.xml project.xml.orig
    %{_bindir}/saxon -o project.xml project.xml.orig %{SOURCE3} map=%{SOURCE4}
    popd
done
for p in $(find . -name project.properties); do
    echo >> $p
    echo maven.repo.remote=file:/usr/share/maven/repository >> $p
    echo maven.home.local=$(pwd)/.maven >> $p
done

export MAVEN_HOME_LOCAL=$(pwd)/.maven
# FIXME: The test compilation is not finding JUnit,
# although it is found fine in JPackage.
maven -Dmaven.test.skip=true -X \
        -Dmaven.repo.remote=file:/usr/share/maven/repository \
		jar:jar

# FIXME: (dwalluck) javadocs are missing
%else
export CLASSPATH=$(build-classpath commons-logging stax_1_0_api)
pushd src
# FIXME: (dwalluck): This class requires axis2
mv ./org/apache/ws/policy/util/OMPolicyReader.java{,.bak}
%{javac} `find . -name '*.java'`
%{__mkdir_p} ../target
%{jar} cfm ../target/policy-1.0.jar %{SOURCE6} `find . -name '*.class'`
popd
%endif

%install
%{__rm} -rf %{buildroot}

install -d -m 755 $RPM_BUILD_ROOT%{_javadir}
install -m 644 target/policy-1.0.jar \
		$RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar

# create unprefixed and unversioned symlinks
(cd $RPM_BUILD_ROOT%{_javadir}
ln -sf %{name}-%{version}.jar %{name}.jar
)

%if %{with_repolib}
	install -d -m 755 $RPM_BUILD_ROOT%{repodir}
	install -d -m 755 $RPM_BUILD_ROOT%{repodirlib}
	install -p -m 644 %{SOURCE5} $RPM_BUILD_ROOT%{repodir}/component-info.xml
	install -d -m 755 $RPM_BUILD_ROOT%{repodirsrc}
	install -p -m 644 %{PATCH1} $RPM_BUILD_ROOT%{repodirsrc}
	install -p -m 644 %{PATCH2} $RPM_BUILD_ROOT%{repodirsrc}
	install -p -m 644 %{SOURCE0} $RPM_BUILD_ROOT%{repodirsrc}
	cp -p $RPM_BUILD_ROOT%{_javadir}/ws-commons-policy.jar $RPM_BUILD_ROOT%{repodirlib}/policy.jar
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(0644,root,root,0755)
%{_javadir}/%{name}.jar
%{_javadir}/%{name}-%{version}.jar

%if %{with_repolib}
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}/repository.jboss.com
%dir %{_javadir}/repository.jboss.com/wscommons-policy
%{repodir}
%endif

%changelog
* Thu Aug 14 2008 David Walluck <dwalluck@redhat.com> 0:1.0-7
- apply properties patch

* Thu Aug 14 2008 David Walluck <dwalluck@redhat.com> 0:1.0-6
- try to fix the neethi/ws-commons-neethi issue
- add missing MANIFEST.MF
- own repolib dirs

* Tue Aug 05 2008 David Walluck <dwalluck@redhat.com> 0:1.0-5
- add option to builkd without maven
- fix repolib permissions

* Thu Jun 12 2008 David Walluck <dwalluck@redhat.com> 0:1.0-4.jpp5
- don't obsolete neethi since this is done by ws-commons-neethi
- add period after repolib description
- call saxon correctly

* Thu May 29 2008 David Walluck <dwalluck@redhat.com> 0:1.0-3.jpp5
- fix License
- do not rebuild %%{buildroot} in %%prep
- add epochs to maven dependencies

* Sat Jan 26 2008 Fernando Nasser <fnasser@redhat.com> 0:1.0-2jpp.ep1.7
- Obsoletes neethi

* Sat Jan 26 2008 Fernando Nasser <fnasser@redhat.com> 0:1.0-2jpp.ep1.6
- Remove spurious dependency on apache-axiom (we use ws-commons-axiom)

* Fri Nov 30 2007 Fernando Nasser <fnasser@redhat.com> 0:1.0-2jpp.ep1.5
- Remove spurious run-time dependency on axis2

* Fri Nov 23 2007 Fernando Nasser <fnasser@redhat.com> 0:1.0-2jpp.ep1.4
- Add missing -brew to component-info

* Fri Nov 23 2007 Fernando Nasser <fnasser@redhat.com> 0:1.0-2jpp.ep1.3
- Really build with repolib

* Fri Nov 23 2007 Fernando Nasser <fnasser@redhat.com> 0:1.0-2jpp.ep1.2
- Build with repolib

* Fri Nov 23 2007 Fernando Nasser <fnasser@redhat.com> 0:1.0-2jpp.ep1.1
- Add repolib bits

* Fri Nov 09 2007 Fernando Nasser <fnasser@redhat.com> 0:1.0-2jpp.1
- Merge with upstream for upgrade to final 1.0
- Disable test runs for now (FIXME)

* Fri Nov 09 2007 Will Tatam <will.tatam@red61.com> 0:1.0-2jpp
- Upgrade to final 1.0

* Wed Mar 15 2006 Fernando Nasser <fnasser@redhat.com> 0:1.0-0.20060119.1jpp_1rh
- First Red Hat build

* Mon Jan 30 2006 Deepak Bhole <dbhole@redhat.com> 0:1.0-0.20060119.1jpp
- Initial build.
